#include <Xm/Xm.h>
#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include "global.h"
#include "../modules/control.h"

void r_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int       item, i, j, b2, ci, pi;
  char      fname[100];
  struct my_msg_struct msg;

  extern void    clearscreen(Window window);
  extern void    showtime(int);
  extern void    real_signal(XtPointer, XtIntervalId*);
  extern Boolean record(XtPointer client_data);
  item=(int) client_data;
  switch(item) {
  case 0:  // start recording;
    if (!reg.recon) {
      reg.recon=1;
      b2=1; ci=0; pi=0;
      reg.nbuftrue=reg.nbuf;
      /* open output file for comments */
      commentdat.open(COMMENTDAT, ios::out);
      for (i=0; i<8 ; i++) {
	if (ch[i].active || (dch[i].nch>0)) ci+=b2;
	if (ch[i].polarity) pi+=b2;
	b2*=2;
        ch[i].buf = (char *)realloc(ch[i].buf, reg.nbuf*2);
        ch[i].min = (int *)realloc(ch[i].min, reg.xpix*sizeof(int));
        ch[i].max = (int *)realloc(ch[i].max, reg.xpix*sizeof(int));
        ch[i].first=0; ch[i].last=0; ch[i].addfirst=0; ch[i].xpos=0; ch[i].nread=0;
	ch[i].analog_sum=0; ch[i].analog_n=0;
        dch[i].mavg=(int *)realloc(dch[i].mavg, dch[i].movavg*sizeof(int));
        dch[i].masum=0;
	for (j=0; j<dch[i].movavg; j++) dch[i].mavg[j]=0;
	for (j=0; j<7; j++) {
	  dch[i].ch[j].min=(int *)realloc(dch[i].ch[j].min, reg.xpix*sizeof(int));
	  dch[i].ch[j].max=(int *)realloc(dch[i].ch[j].max, reg.xpix*sizeof(int));
	  dch[i].ch[j].first=0; dch[i].ch[j].last=0; dch[i].ch[j].addfirst=0;
	  dch[i].ch[j].xpos=0; dch[i].ch[j].nread=0;
	  dch[i].ch[j].analog_sum=0; dch[i].ch[j].analog_n=0;
	}
	// open files for direct channels;
	sprintf(fname, DIRECTDAT".%d", i);
	datei[i].open(fname, ios::out | ios::bin | ios::trunc);
	// open files for derived channels;
	sprintf(fname, DERIVEDDAT".%d", i);
	derdat[i].open(fname, ios::out | ios::bin | ios::trunc);
	// empty fifos;
	while (read(fd[i], (char *) ch[i].buf, 2)>0) {;}
      }
      msg.command=SET_POL; msg.value=pi;
      write(fd8, &msg, sizeof(msg));
      msg.command=SET_CH; msg.value=ci;
      write(fd8, &msg, sizeof(msg));
      msg.value=0;
      for (i=0; i<8; i++) {
	if (ch[i].active || dch[i].nch>0) msg.value++;
      }
      msg.command=SET_SR; msg.value*=reg.sr;
      write(fd8, &msg, sizeof(msg));
      XtSetSensitive(mymenu.file.f_menu,False);
      if (reg.store) {
	reg.needsave=1;
	XtSetSensitive(mymenu.file.s_data,True);
	XtVaSetValues(comment_label, XmNeditable, True, NULL);
      }
      XtSetSensitive(mymenu.recording.s_recording,False);
      XtSetSensitive(mymenu.recording.e_recording,True);
      XtSetSensitive(mymenu.calibrate.c_menu,False);
      XtSetSensitive(mymenu.options.srate,False);
      XtSetSensitive(mymenu.options.achannel,False);
      clearscreen(XtWindow(drawing_a));
      msg.command=START_TASK; msg.value=0;
      write(fd8, &msg, sizeof(msg));
      showtime(0); // reset timer to zero; 
      if (!reg.store) showtime(2);  // stop timer;
      work_id=XtAppAddWorkProc(app, record, NULL);
    }
    break;
  case 1:
    if (reg.recon) {
      reg.recon=0;
      msg.command=STOP_TASK; msg.value=0;
      write(fd8, &msg, sizeof(msg));
      msg.command=SET_SR; msg.value=1;
      write(fd8, &msg, sizeof(msg));
      msg.command=SET_CH; msg.value=0;
      write(fd8, &msg, sizeof(msg));
      msg.command=SET_POL; msg.value=0;
      write(fd8, &msg, sizeof(msg));
      /* close files */
      commentdat.close();
      for (i=0; i<8; i++) {
	datei[i].close();
	derdat[i].close();
      }
      XtRemoveWorkProc(work_id);
      if (reg.store) {
	showtime(4); // show recording duration anyway;
	XtSetSensitive(mymenu.file.s_data,True);
      }
      XtVaSetValues(comment_label, XmNeditable, False, NULL);
      XtSetSensitive(mymenu.file.f_menu,True);
      XtSetSensitive(mymenu.recording.s_recording,True);
      XtSetSensitive(mymenu.recording.e_recording,False);
      XtSetSensitive(mymenu.calibrate.c_menu,True);
      XtSetSensitive(mymenu.options.srate,True);
      XtSetSensitive(mymenu.options.achannel,True);
    }
    break;
  }
}
